/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */
package com.jcg.largestprimefinder;

/**
 *
 * @author omozegieaziegbe
 */
public class LargestPrimeFinder {

    // Helper method to check if a number is prime
    private static boolean isPrime(int num) {
        if (num <= 1) {
            return false;
        }
        // Check divisibility from 2 to num-1
        for (int i = 2; i < num; i++) {
            if (num % i == 0) {
                return false;
            }
        }
        return true;
    }

    // Method to find the largest prime less than a given number using brute force
    public static int largestPrimeUnder(int n) {
        if (n <= 2) {
            return -1; // No prime less than or equal to 2
        }

        // Check numbers from n-1 downwards to 2
        for (int i = n - 1; i > 1; i--) {
            if (isPrime(i)) {
                return i;
            }
        }

        return -1; // If no prime found (which should not happen for n > 2)
    }

    public static void main(String[] args) {
        int number = 100;
        int largestPrime = largestPrimeUnder(number);

        if (largestPrime != -1) {
            System.out.println("Largest prime under " + number + " is: " + largestPrime);
        } else {
            System.out.println("No prime found less than " + number);
        }
    }
}
