/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */

package com.jcg;

import java.util.*;

/**
 *
 * @author omozegieaziegbe
 */
public class LargestPrimeSieveOfEratosthenes {

    public static List<Integer> sieveOfEratosthenes(int n) {
        boolean[] isPrime = new boolean[n + 1];
        Arrays.fill(isPrime, true);
        List<Integer> primes = new ArrayList<>();

        for (int i = 2; i <= n; i++) {
            if (isPrime[i]) {
                primes.add(i);
                for (int j = i * 2; j <= n; j += i) {
                    isPrime[j] = false;
                }
            }
        }

        return primes;
    }

    public static int largestPrimeUnder(int n) {
        if (n <= 1) {
            return -1; // No prime less than or equal to 1
        }

        List<Integer> primes = sieveOfEratosthenes(n - 1);

        // Find the largest prime less than n
        for (int i = primes.size() - 1; i >= 0; i--) {
            if (primes.get(i) < n) {
                return primes.get(i);
            }
        }

        return -1; // If no prime found (which should not happen for n > 1)
    }

    public static void main(String[] args) {
        int number = 50;
        int largestPrime = largestPrimeUnder(number);

        if (largestPrime != -1) {
            System.out.println("Largest prime under " + number + " is: " + largestPrime);
        } else {
            System.out.println("No prime found less than " + number);
        }
    }
}